const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const subjects = sequelize.define(
    'subjects',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

subject_name: {
        type: DataTypes.TEXT,
      
      

      },

subject_code: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  subjects.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity










    db.subjects.hasMany(db.teaching_assignments, {
      as: 'teaching_assignments_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });


    db.subjects.hasMany(db.homeworks, {
      as: 'homeworks_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });







    db.subjects.hasMany(db.gradebooks, {
      as: 'gradebooks_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });















//end loop



    db.subjects.belongsTo(db.schools, {
      as: 'school',
      foreignKey: {
        name: 'schoolId',
      },
      constraints: false,
    });

    db.subjects.belongsTo(db.grade_levels, {
      as: 'grade_level',
      foreignKey: {
        name: 'grade_levelId',
      },
      constraints: false,
    });




    db.subjects.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.subjects.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return subjects;
};


